function [W,obj] = e_step(H,speed_up,W,obj,SigmaS,entr,sd,D)

N = length(W);

if speed_up==1
    
    [tmp , order] = min(sd,[],2); 
    J = find(order~=W);
    order = order(J);
    tmp_obj=  -sum(sd(J,:) .* H(:,order)',2) / (2*SigmaS) +entr(order)'-D*log(SigmaS)/2;
  
    I         = find( tmp_obj >= obj(J) );
    obj(J(I)) = tmp_obj(I);
    W(J(I))   = order(I);
    
    
elseif speed_up>1
    
    [tmp , order] = sort(sd,2); 
    order = order(:,1:speed_up);
    for n = 1:N   
        [tmp_obj(n), win] = max( -sd(n,:) * H(:,order(n,:)) / (2*SigmaS) +entr(order(n,:))-D*log(SigmaS)/2);
        tmp_win(n)=order(n,win);
    end
    I=find(tmp_obj>=obj');
    obj(I) = tmp_obj(I);
    W(I) = tmp_win(I);
  
else
      
  [obj,W] = max(-sd*H/(2*SigmaS) + ones(N,1)*entr-D*log(SigmaS)/2 ,[],2);

end    
